package com.mybank;

import java.math.BigDecimal;


public class TradeMonitor
{
    private LimitRepository repository;

    public TradeMonitor(LimitRepository repository)
    {
        this.repository = repository;
    }

    public boolean tryTrade(String symbol, BigDecimal amount)
    {
        BigDecimal currentExp = repository.getExposure(symbol);
        BigDecimal newExp = currentExp.add(amount);
        BigDecimal limit = repository.getLimit(symbol);
        if(newExp.compareTo(limit) > 0)
            return false;
        repository.updateExposure(newExp, symbol);
        return true;
    }

}
