package com.mybank.config;

import com.mybank.TradeMonitor;

import java.io.FileReader;
import java.io.FileNotFoundException;

import org.nanocontainer.script.ScriptedContainerBuilder;
import org.nanocontainer.script.xml.XMLContainerBuilder;
import org.picocontainer.defaults.ObjectReference;
import org.picocontainer.defaults.SimpleReference;
import org.picocontainer.PicoContainer;

public class NanoConfigurator implements Configurator
{
    public TradeMonitor getTradeMonitor()
    {
        ScriptedContainerBuilder builder = getXmlContainerBuilder("src/config/nano.xml");
        ObjectReference containerRef = new SimpleReference();
        builder.buildContainer(containerRef, null, null, true);
        PicoContainer pico = (PicoContainer)containerRef.get();

        return (TradeMonitor)pico.getComponentInstanceOfType(TradeMonitor.class);

    }

    private ScriptedContainerBuilder getXmlContainerBuilder(String fileName)
    {
        try
        {
            FileReader script = new FileReader(fileName);
            ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
            return new XMLContainerBuilder(script, classLoader);
        }
        catch(FileNotFoundException e)
        {
            throw new RuntimeException("Could not find config file.", e);
        }
    }
}
