package com.mybank;

import org.jmock.Mock;
import org.jmock.MockObjectTestCase;

import java.math.BigDecimal;


public class TradeMonitorTest extends MockObjectTestCase
{

    public void testPassesTradeIfLimitIsNotReached()
    {
        Mock repositoryMock = mock(LimitRepository.class);
        LimitRepository repository = (LimitRepository)repositoryMock.proxy();

        repositoryMock.expects(once()).method("getLimit").with(eq("ACME")).will(returnValue(new BigDecimal(5000000)));
        repositoryMock.expects(once()).method("getExposure").with(eq("ACME")).will(returnValue(new BigDecimal(1000000)));
        repositoryMock.expects(once()).method("updateExposure").with(eq(new BigDecimal("4000000")), eq("ACME"));

        TradeMonitor monitor = new TradeMonitor(repository);

        boolean result = monitor.tryTrade("ACME", new BigDecimal("3000000"));

        assertTrue(result);
        repositoryMock.verify();
    }


}
